"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AppModule = void 0;
const common_1 = require("@nestjs/common");
const app_controller_1 = require("./app.controller");
const app_service_1 = require("./app.service");
const schedule_1 = require("@nestjs/schedule");
const platform_express_1 = require("@nestjs/platform-express");
const path = require("path");
const serve_static_1 = require("@nestjs/serve-static");
const event_emitter_1 = require("@nestjs/event-emitter");
const _module_loader_module_1 = require("./common/helpers/moduleLoader/ module-loader.module");
const nest_winston_1 = require("nest-winston");
const winston_1 = require("./config/winston");
const typeorm_1 = require("@nestjs/typeorm");
const typeorm_config_1 = require("./config/typeorm.config");
let AppModule = class AppModule {
};
AppModule = __decorate([
    (0, common_1.Module)({
        imports: [
            nest_winston_1.WinstonModule.forRoot(winston_1.default),
            typeorm_1.TypeOrmModule.forRoot(typeorm_config_1.typeormConfig),
            event_emitter_1.EventEmitterModule.forRoot({ wildcard: true }),
            _module_loader_module_1.ModuleLoaderModule.register({
                name: 'db-entities',
                path: path.resolve(__dirname, './modules'),
                fileSpec: '**/*.module.js',
            }),
            schedule_1.ScheduleModule.forRoot(),
            platform_express_1.MulterModule.register({
                dest: './public',
            }),
            serve_static_1.ServeStaticModule.forRoot({
                rootPath: path.join(__dirname, '..', 'public'),
            }),
        ],
        controllers: [app_controller_1.AppController],
        providers: [app_service_1.AppService],
    })
], AppModule);
exports.AppModule = AppModule;
//# sourceMappingURL=app.module.js.map