"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChangePasswordDto = exports.ResetPasswordDTO = exports.StartResetPasswordDTO = exports.ChangePasswordDTO = exports.LoginDTO = exports.ValidateRegistrationDTO = exports.UserBankDTO = exports.EditUserDTO = exports.RegisterDTO = void 0;
const openapi = require("@nestjs/swagger");
const class_validator_1 = require("class-validator");
const swagger_1 = require("@nestjs/swagger");
const is_equal_to_decorator_1 = require("../decorators/is-equal-to.decorator");
class RegisterDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { email: { required: true, type: () => String }, password: { required: true, type: () => String }, first_name: { required: true, type: () => String }, last_name: { required: true, type: () => String }, role: { required: true, type: () => String }, phone: { required: true, type: () => String } };
    }
}
__decorate([
    (0, class_validator_1.IsString)({ message: 'Email address is required' }),
    (0, class_validator_1.IsEmail)(),
    (0, swagger_1.ApiProperty)(),
    __metadata("design:type", String)
], RegisterDTO.prototype, "email", void 0);
__decorate([
    (0, swagger_1.ApiPropertyOptional)(),
    __metadata("design:type", String)
], RegisterDTO.prototype, "password", void 0);
__decorate([
    (0, swagger_1.ApiPropertyOptional)(),
    __metadata("design:type", String)
], RegisterDTO.prototype, "first_name", void 0);
__decorate([
    (0, swagger_1.ApiPropertyOptional)(),
    __metadata("design:type", String)
], RegisterDTO.prototype, "last_name", void 0);
__decorate([
    (0, swagger_1.ApiPropertyOptional)(),
    __metadata("design:type", String)
], RegisterDTO.prototype, "role", void 0);
__decorate([
    (0, swagger_1.ApiPropertyOptional)(),
    __metadata("design:type", String)
], RegisterDTO.prototype, "phone", void 0);
exports.RegisterDTO = RegisterDTO;
class EditUserDTO {
    get whatsApp() {
        return this._whatsApp;
    }
    set whatsApp(value) {
        this._whatsApp = value;
    }
    static _OPENAPI_METADATA_FACTORY() {
        return { first_name: { required: true, type: () => String }, last_name: { required: true, type: () => String }, phone: { required: true, type: () => String }, roleId: { required: true, type: () => String }, instagram: { required: true, type: () => String }, facebook: { required: true, type: () => String }, pInterest: { required: true, type: () => String }, snapchat: { required: true, type: () => String }, twitter: { required: true, type: () => String }, _whatsApp: { required: true, type: () => String } };
    }
}
__decorate([
    (0, class_validator_1.IsString)({ message: 'First Name is required' }),
    (0, swagger_1.ApiProperty)(),
    __metadata("design:type", String)
], EditUserDTO.prototype, "first_name", void 0);
__decorate([
    (0, class_validator_1.IsString)({ message: 'Last Name is required' }),
    (0, swagger_1.ApiProperty)(),
    __metadata("design:type", String)
], EditUserDTO.prototype, "last_name", void 0);
__decorate([
    (0, class_validator_1.IsString)({ message: 'Phone Number is required' }),
    (0, swagger_1.ApiProperty)(),
    __metadata("design:type", String)
], EditUserDTO.prototype, "phone", void 0);
__decorate([
    (0, class_validator_1.IsString)({ message: 'Role is required' }),
    (0, swagger_1.ApiProperty)(),
    __metadata("design:type", String)
], EditUserDTO.prototype, "roleId", void 0);
__decorate([
    (0, swagger_1.ApiPropertyOptional)(),
    __metadata("design:type", String)
], EditUserDTO.prototype, "instagram", void 0);
__decorate([
    (0, swagger_1.ApiPropertyOptional)(),
    __metadata("design:type", String)
], EditUserDTO.prototype, "facebook", void 0);
__decorate([
    (0, swagger_1.ApiPropertyOptional)(),
    __metadata("design:type", String)
], EditUserDTO.prototype, "pInterest", void 0);
__decorate([
    (0, swagger_1.ApiPropertyOptional)(),
    __metadata("design:type", String)
], EditUserDTO.prototype, "snapchat", void 0);
__decorate([
    (0, swagger_1.ApiPropertyOptional)(),
    __metadata("design:type", String)
], EditUserDTO.prototype, "twitter", void 0);
__decorate([
    (0, swagger_1.ApiPropertyOptional)(),
    __metadata("design:type", String)
], EditUserDTO.prototype, "_whatsApp", void 0);
exports.EditUserDTO = EditUserDTO;
class UserBankDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { bank_name: { required: true, type: () => String }, account_number: { required: true, type: () => String }, account_name: { required: true, type: () => String } };
    }
}
__decorate([
    (0, class_validator_1.IsString)({ message: 'Bank Name is required' }),
    (0, swagger_1.ApiProperty)(),
    __metadata("design:type", String)
], UserBankDTO.prototype, "bank_name", void 0);
__decorate([
    (0, class_validator_1.IsString)({ message: 'Account Number is required' }),
    (0, swagger_1.ApiProperty)(),
    __metadata("design:type", String)
], UserBankDTO.prototype, "account_number", void 0);
__decorate([
    (0, class_validator_1.IsString)({ message: 'Account Name is required' }),
    (0, swagger_1.ApiProperty)(),
    __metadata("design:type", String)
], UserBankDTO.prototype, "account_name", void 0);
exports.UserBankDTO = UserBankDTO;
class ValidateRegistrationDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { email: { required: true, type: () => String }, token: { required: true, type: () => String } };
    }
}
__decorate([
    (0, class_validator_1.IsString)({ message: 'Email address is required' }),
    (0, class_validator_1.IsEmail)(),
    (0, swagger_1.ApiProperty)(),
    __metadata("design:type", String)
], ValidateRegistrationDTO.prototype, "email", void 0);
__decorate([
    (0, swagger_1.ApiPropertyOptional)(),
    __metadata("design:type", String)
], ValidateRegistrationDTO.prototype, "token", void 0);
exports.ValidateRegistrationDTO = ValidateRegistrationDTO;
class LoginDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { email: { required: true, type: () => String }, password: { required: true, type: () => String } };
    }
}
__decorate([
    (0, class_validator_1.IsString)({ message: 'Email address is required' }),
    (0, class_validator_1.IsEmail)(),
    (0, swagger_1.ApiProperty)(),
    __metadata("design:type", String)
], LoginDTO.prototype, "email", void 0);
__decorate([
    (0, class_validator_1.IsString)({ message: 'Password is required' }),
    (0, swagger_1.ApiProperty)(),
    __metadata("design:type", String)
], LoginDTO.prototype, "password", void 0);
exports.LoginDTO = LoginDTO;
class ChangePasswordDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { password: { required: true, type: () => String }, old_password: { required: true, type: () => String } };
    }
}
__decorate([
    (0, class_validator_1.IsString)({ message: 'New Password is required' }),
    (0, swagger_1.ApiProperty)(),
    __metadata("design:type", String)
], ChangePasswordDTO.prototype, "password", void 0);
__decorate([
    (0, class_validator_1.IsString)({ message: 'Old password is required' }),
    (0, swagger_1.ApiProperty)(),
    __metadata("design:type", String)
], ChangePasswordDTO.prototype, "old_password", void 0);
exports.ChangePasswordDTO = ChangePasswordDTO;
class StartResetPasswordDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { email: { required: true, type: () => String } };
    }
}
__decorate([
    (0, class_validator_1.IsString)({ message: 'Email is required' }),
    (0, swagger_1.ApiProperty)(),
    __metadata("design:type", String)
], StartResetPasswordDTO.prototype, "email", void 0);
exports.StartResetPasswordDTO = StartResetPasswordDTO;
class ResetPasswordDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { password: { required: true, type: () => String }, email: { required: true, type: () => String }, token: { required: true, type: () => String } };
    }
}
__decorate([
    (0, class_validator_1.IsString)({ message: 'Password is required' }),
    (0, swagger_1.ApiProperty)(),
    __metadata("design:type", String)
], ResetPasswordDTO.prototype, "password", void 0);
__decorate([
    (0, class_validator_1.IsString)({ message: 'Email is required' }),
    (0, swagger_1.ApiProperty)(),
    __metadata("design:type", String)
], ResetPasswordDTO.prototype, "email", void 0);
__decorate([
    (0, class_validator_1.IsString)({ message: 'Token is required' }),
    (0, swagger_1.ApiProperty)(),
    __metadata("design:type", String)
], ResetPasswordDTO.prototype, "token", void 0);
exports.ResetPasswordDTO = ResetPasswordDTO;
class ChangePasswordDto {
    static _OPENAPI_METADATA_FACTORY() {
        return { oldPassword: { required: true, type: () => String }, password: { required: true, type: () => String, minLength: 6, maxLength: 20, pattern: "/^(?=.*\\d)(?=.*[a-z])(?=.*[A-Z])(?=.*[^a-zA-Z0-9])(?!.*\\s).{6,20}$/" }, confirmPassword: { required: true, type: () => String } };
    }
}
__decorate([
    (0, class_validator_1.IsNotEmpty)(),
    __metadata("design:type", String)
], ChangePasswordDto.prototype, "oldPassword", void 0);
__decorate([
    (0, class_validator_1.IsNotEmpty)(),
    (0, class_validator_1.MinLength)(6, {
        message: 'minLength-{"ln":6,"count":6}',
    }),
    (0, class_validator_1.MaxLength)(20, {
        message: 'maxLength-{"ln":20,"count":20}',
    }),
    (0, class_validator_1.Matches)(/^(?=.*\d)(?=.*[a-z])(?=.*[A-Z])(?=.*[^a-zA-Z0-9])(?!.*\s).{6,20}$/, {
        message: 'password should contain at least one lowercase letter, one uppercase letter, one numeric digit, and one special character',
    }),
    __metadata("design:type", String)
], ChangePasswordDto.prototype, "password", void 0);
__decorate([
    (0, class_validator_1.IsNotEmpty)(),
    (0, is_equal_to_decorator_1.IsEqualTo)('password', {
        message: 'isEqualTo-{"field":"password"}',
    }),
    __metadata("design:type", String)
], ChangePasswordDto.prototype, "confirmPassword", void 0);
exports.ChangePasswordDto = ChangePasswordDto;
//# sourceMappingURL=admin.dto.js.map