"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GlobalExceptionsFilter = void 0;
const common_1 = require("@nestjs/common");
const logger_1 = require("../helpers/logger/logger");
let GlobalExceptionsFilter = class GlobalExceptionsFilter {
    catch(exception, host) {
        const ctx = host.switchToHttp();
        const response = ctx.getResponse();
        try {
            const status = false;
            let success, resObj, data, message;
            if (exception instanceof common_1.HttpException) {
                success = exception.getStatus();
                resObj = exception.getResponse();
                (message = resObj.message), (data = resObj.data || undefined);
            }
            else {
                success = common_1.HttpStatus.BAD_REQUEST;
                resObj = exception;
                message =
                    resObj.message || 'Sorry, we are unable to process your request';
                data = {
                    message: resObj.message,
                    stack: resObj.stack,
                };
                logger_1.AppLogger.verbose(resObj);
            }
            return response.status(success).json({
                status,
                message: Array.isArray(message) ? message[0] : message,
            });
        }
        catch (e) {
            response.status(400).json({
                status: false,
                message: 'Sorry, we are unable to process your request',
            });
        }
    }
};
GlobalExceptionsFilter = __decorate([
    (0, common_1.Catch)(common_1.HttpException)
], GlobalExceptionsFilter);
exports.GlobalExceptionsFilter = GlobalExceptionsFilter;
//# sourceMappingURL=http-filter.exception.js.map