"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AdminGuard = void 0;
const common_1 = require("@nestjs/common");
const jsonwebtoken_1 = require("jsonwebtoken");
const config = require("config");
const admin_service_1 = require("../../modules/admin/admin.service");
const jwtConfig = config.get('jwt');
let AdminGuard = class AdminGuard {
    constructor(adminService) {
        this.adminService = adminService;
    }
    async canActivate(context) {
        const request = context.switchToHttp().getRequest();
        const Authorization = request.get('Authorization');
        if (!Authorization) {
            throw new common_1.UnauthorizedException('Unauthorized request');
        }
        const token = Authorization.split(' ');
        if (!((token[1] && token[0] === 'Bearer') || token[0] === 'bearer')) {
            throw new common_1.UnauthorizedException('Unauthorized request');
        }
        let decrypt;
        try {
            decrypt = await (0, jsonwebtoken_1.verify)(token[1], jwtConfig.secret);
        }
        catch (e) {
            throw new common_1.UnauthorizedException('Unauthorized request');
        }
        if (!decrypt) {
            throw new common_1.UnauthorizedException('Unauthorized request');
        }
        const user = await this.adminService.getOne(decrypt.id);
        if (!user) {
            throw new common_1.UnauthorizedException('Unauthorized request');
        }
        request.admin = user;
        return true;
    }
};
AdminGuard = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [admin_service_1.AdminService])
], AdminGuard);
exports.AdminGuard = AdminGuard;
//# sourceMappingURL=admin.guard.js.map