"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Helper = void 0;
const cloudinary_1 = require("cloudinary");
const toStream = require("buffer-to-stream");
const typeorm_1 = require("typeorm");
const date_fns_1 = require("date-fns");
class Helper {
    static async imageHandler(file) {
        return new Promise((resolve, reject) => {
            const upload = cloudinary_1.v2.uploader.upload_stream((error, result) => {
                if (error)
                    return reject(error);
                resolve(result);
            });
            toStream(file.buffer).pipe(upload);
        });
    }
    static async uploadFile(image) {
        if (!image)
            return {
                url: null,
            };
        cloudinary_1.v2.config({
            cloud_name: 'nimiafrica',
            api_key: '828557676927733',
            api_secret: 'JIEDEimQ8eCqajhzVMILe2E1DyQ',
        });
        const upload = await this.imageHandler(image);
        return {
            url: upload.secure_url,
        };
    }
    static slug(text) {
        text = text.toLowerCase();
        text = text.replace(/[^a-z0-9 -]/g, '');
        text = text.replace(/\s+/g, '-');
        text = text.replace(/-+/g, '-');
        return text;
    }
    static customFileName(req, file, cb) {
        const uniqueSuffix = Date.now() + '-' + Math.round(Math.random() * 1e9);
        let fileExtension = '';
        if (file.mimetype.indexOf('jpeg') > -1 ||
            file.mimetype.indexOf('jpg') > -1) {
            fileExtension = 'jpg';
        }
        else if (file.mimetype.indexOf('png') > -1) {
            fileExtension = 'png';
        }
        const originalName = file.originalname.split('.')[0];
        cb(null, originalName + '-' + uniqueSuffix + '.' + fileExtension);
    }
    static destinationEventPath(req, file, cb) {
        cb(null, 'public/documents/events');
    }
    static destinationDiscussionPath(req, file, cb) {
        cb(null, 'public/documents/discussions');
    }
    static randonCode(length) {
        let result = '';
        const characters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
        const charactersLength = characters.length;
        let counter = 0;
        while (counter < length) {
            result += characters.charAt(Math.floor(Math.random() * charactersLength));
            counter += 1;
        }
        return result;
    }
}
exports.Helper = Helper;
Helper.betweenDates = (from, to) => (0, typeorm_1.Between)((0, date_fns_1.format)(typeof from === 'string' ? new Date(from) : from, 'YYYY-MM-DD HH:MM:SS'), (0, date_fns_1.format)(typeof to === 'string' ? new Date(to) : to, 'YYYY-MM-DD HH:MM:SS'));
//# sourceMappingURL=helper.js.map