"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JwtUtilities = void 0;
const jsonwebtoken_1 = require("jsonwebtoken");
const config = require("config");
const jwtConfig = config.get('jwt');
class JwtUtilities {
    static async signToken(user) {
        const payload = {
            id: user.id,
        };
        return (0, jsonwebtoken_1.sign)(payload, jwtConfig.secret, { expiresIn: '2hr' });
    }
    static async signRefreshToken(user) {
        const payload = {
            id: user.id,
        };
        return (0, jsonwebtoken_1.sign)(payload, jwtConfig.secret, { expiresIn: 60 * 60 * 24 * 7 });
    }
    static async adminSignToken(user) {
        const payload = {
            id: user.id,
        };
        return (0, jsonwebtoken_1.sign)(payload, jwtConfig.secret, { expiresIn: '2hr' });
    }
    static async adminSignRefreshToken(user) {
        const payload = {
            id: user.id,
        };
        return (0, jsonwebtoken_1.sign)(payload, jwtConfig.secret, { expiresIn: 60 * 60 * 24 * 7 });
    }
}
exports.JwtUtilities = JwtUtilities;
//# sourceMappingURL=jwt.utilities.js.map