"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HttpRequest = void 0;
const axios_1 = require("axios");
const common_1 = require("@nestjs/common");
class HttpRequest {
    static async sendRequest(requestConfig) {
        try {
            const response = await (0, axios_1.default)(requestConfig);
            return response.data;
        }
        catch (err) {
            throw new common_1.BadRequestException(err.response.data.message || err.response.data.error);
        }
    }
}
exports.HttpRequest = HttpRequest;
//# sourceMappingURL=request.utilities.js.map