"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.databaseProviders = void 0;
const typeorm_1 = require("typeorm");
const config = require("config");
const dbConfig = config.get('db');
exports.databaseProviders = [
    {
        provide: 'DATA_SOURCE',
        useFactory: async () => {
            const dataSource = new typeorm_1.DataSource({
                type: 'mysql' || dbConfig.type,
                host: dbConfig.host,
                port: dbConfig.port,
                url: dbConfig.url,
                username: dbConfig.username,
                password: dbConfig.password,
                database: dbConfig.database,
                entities: [__dirname + '/../**/*.entity{.ts,.js}'],
                synchronize: dbConfig.synchronize,
            });
            return dataSource.initialize();
        },
    },
];
//# sourceMappingURL=database.providers.js.map