"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.setupSwagger = void 0;
const swagger_1 = require("@nestjs/swagger");
const swagger_2 = require("../common/constants/swagger");
const setupSwagger = (app) => {
    const options = new swagger_1.DocumentBuilder()
        .setTitle(swagger_2.SWAGGER_API_NAME)
        .setDescription(swagger_2.SWAGGER_API_DESCRIPTION)
        .setVersion(swagger_2.SWAGGER_API_CURRENT_VERSION)
        .addBearerAuth()
        .build();
    const document = swagger_1.SwaggerModule.createDocument(app, options, {
        ignoreGlobalPrefix: false,
    });
    swagger_1.SwaggerModule.setup(swagger_2.SWAGGER_API_ROOT, app, document);
};
exports.setupSwagger = setupSwagger;
//# sourceMappingURL=swagger.config.js.map