"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.User = void 0;
const openapi = require("@nestjs/swagger");
const base_entity_1 = require("./base.entity");
const typeorm_1 = require("typeorm");
const class_transformer_1 = require("class-transformer");
const user_event_entity_1 = require("./user-event.entity");
const santa_entity_1 = require("./santa.entity");
const user_award_entity_1 = require("./user-award.entity");
const user_score_entity_1 = require("./user-score.entity");
const discussion_entity_1 = require("./discussion.entity");
let User = class User extends base_entity_1.AbstractEntity {
    static _OPENAPI_METADATA_FACTORY() {
        return { firstName: { required: true, type: () => String }, lastName: { required: true, type: () => String }, email: { required: true, type: () => String }, favouriteLeisure: { required: true, type: () => String }, hobby: { required: true, type: () => String }, wishlist: { required: true, type: () => String }, phone: { required: true, type: () => String }, joinSanta: { required: true, type: () => Boolean }, position: { required: true, type: () => String }, verification_token: { required: true, type: () => Number }, active: { required: true, type: () => Boolean }, admin: { required: true, type: () => Boolean }, isCheckedIn: { required: true, type: () => Boolean }, checkedIndate: { required: true, type: () => Date }, activeTicket: { required: true, type: () => Boolean }, santaId: { required: true, type: () => Number }, userEvents: { required: true, type: () => [require("./user-event.entity").UserEvent] }, userScores: { required: true, type: () => [require("./user-score.entity").UserScore] }, firstSanta: { required: true, type: () => require("./santa.entity").Santa }, secondSanta: { required: true, type: () => require("./santa.entity").Santa }, awardByUsers: { required: true, type: () => [require("./user-award.entity").UserAward] }, userAwards: { required: true, type: () => [require("./user-award.entity").UserAward] }, discussions: { required: true, type: () => [require("./discussion.entity").Discussion] } };
    }
};
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", String)
], User.prototype, "firstName", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", String)
], User.prototype, "lastName", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: false }),
    __metadata("design:type", String)
], User.prototype, "email", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", String)
], User.prototype, "favouriteLeisure", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", String)
], User.prototype, "hobby", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", String)
], User.prototype, "wishlist", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", String)
], User.prototype, "phone", void 0);
__decorate([
    (0, typeorm_1.Column)({
        default: false,
    }),
    __metadata("design:type", Boolean)
], User.prototype, "joinSanta", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", String)
], User.prototype, "position", void 0);
__decorate([
    (0, class_transformer_1.Exclude)(),
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", Number)
], User.prototype, "verification_token", void 0);
__decorate([
    (0, typeorm_1.Column)({
        default: false,
    }),
    __metadata("design:type", Boolean)
], User.prototype, "active", void 0);
__decorate([
    (0, typeorm_1.Column)({
        default: false,
    }),
    __metadata("design:type", Boolean)
], User.prototype, "admin", void 0);
__decorate([
    (0, typeorm_1.Column)({
        default: false,
    }),
    __metadata("design:type", Boolean)
], User.prototype, "isCheckedIn", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", Date)
], User.prototype, "checkedIndate", void 0);
__decorate([
    (0, typeorm_1.Column)({
        default: false,
    }),
    __metadata("design:type", Boolean)
], User.prototype, "activeTicket", void 0);
__decorate([
    (0, typeorm_1.Column)({ default: false, name: 'santaId', type: 'int' }),
    __metadata("design:type", Number)
], User.prototype, "santaId", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => user_event_entity_1.UserEvent, (row) => row.user),
    __metadata("design:type", Array)
], User.prototype, "userEvents", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => user_score_entity_1.UserScore, (row) => row.user),
    __metadata("design:type", Array)
], User.prototype, "userScores", void 0);
__decorate([
    (0, typeorm_1.OneToOne)(() => santa_entity_1.Santa, (row) => row.firstUser),
    __metadata("design:type", santa_entity_1.Santa)
], User.prototype, "firstSanta", void 0);
__decorate([
    (0, typeorm_1.OneToOne)(() => santa_entity_1.Santa, (row) => row.secondUser),
    __metadata("design:type", santa_entity_1.Santa)
], User.prototype, "secondSanta", void 0);
__decorate([
    (0, typeorm_1.OneToOne)(() => user_award_entity_1.UserAward, (row) => row.createdBy),
    __metadata("design:type", Array)
], User.prototype, "awardByUsers", void 0);
__decorate([
    (0, typeorm_1.OneToOne)(() => user_award_entity_1.UserAward, (row) => row.user),
    __metadata("design:type", Array)
], User.prototype, "userAwards", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => discussion_entity_1.Discussion, (row) => row.user),
    __metadata("design:type", Array)
], User.prototype, "discussions", void 0);
User = __decorate([
    (0, typeorm_1.Entity)('user'),
    (0, typeorm_1.Unique)(['email'])
], User);
exports.User = User;
//# sourceMappingURL=user.entity.js.map