import { ChangePasswordDTO, EditUserDTO, LoginDTO, RegisterDTO, ResetPasswordDTO, StartResetPasswordDTO, ValidateRegistrationDTO } from '../../common/dto/admin.dto';
import { AdminService } from './admin.service';
import { Admin } from 'src/models/admin.entity';
export declare class AdminController {
    private readonly adminService;
    constructor(adminService: AdminService);
    register(data: RegisterDTO): Promise<{
        status: boolean;
        message: string;
        data?: undefined;
    } | {
        status: boolean;
        message: string;
        data: any;
    }>;
    verifyRegistration(body: ValidateRegistrationDTO): Promise<{
        status: boolean;
        message: string;
        data?: undefined;
    } | {
        status: boolean;
        message: string;
        data: any;
    }>;
    login(body: LoginDTO): Promise<{
        status: boolean;
        message: string;
        data?: undefined;
    } | {
        status: boolean;
        message: string;
        data: any;
    }>;
    startResetPassword(body: StartResetPasswordDTO): Promise<{
        status: boolean;
        message: string;
        data?: undefined;
    } | {
        status: boolean;
        message: string;
        data: any;
    }>;
    resetPassword(body: ResetPasswordDTO): Promise<{
        status: boolean;
        message: string;
        data?: undefined;
    } | {
        status: boolean;
        message: string;
        data: any;
    }>;
    editStore(data: EditUserDTO, admin: Admin): Promise<{
        status: boolean;
        message: string;
        data?: undefined;
    } | {
        status: boolean;
        message: string;
        data: any;
    }>;
    changePassword(body: ChangePasswordDTO, admin: Admin): Promise<{
        status: boolean;
        message: string;
        data?: undefined;
    } | {
        status: boolean;
        message: string;
        data: any;
    }>;
    getAll(): Promise<{
        status: boolean;
        message: string;
        data?: undefined;
    } | {
        status: boolean;
        message: string;
        data: any;
    }>;
    get(id: any): Promise<{
        status: boolean;
        message: string;
        data?: undefined;
    } | {
        status: boolean;
        message: string;
        data: any;
    }>;
    onDelete(id: any): Promise<void>;
}
