"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AdminController = void 0;
const openapi = require("@nestjs/swagger");
const common_1 = require("@nestjs/common");
const success_response_1 = require("../../common/helpers/responses/success.response");
const admin_dto_1 = require("../../common/dto/admin.dto");
const decorators_1 = require("../../common/decorators");
const admin_service_1 = require("./admin.service");
const admin_entity_1 = require("../../models/admin.entity");
const admin_guard_1 = require("../../common/guards/admin.guard");
let AdminController = class AdminController {
    constructor(adminService) {
        this.adminService = adminService;
    }
    async register(data) {
        const response = await this.adminService.register(data);
        return success_response_1.HttpResponse.send('The account has been cresated successfully', response);
    }
    async verifyRegistration(body) {
        const response = await this.adminService.verifyRegistration(body);
        return success_response_1.HttpResponse.send('Registration is successful', response);
    }
    async login(body) {
        const response = await this.adminService.login(body);
        return success_response_1.HttpResponse.send('Login successful', response);
    }
    async startResetPassword(body) {
        await this.adminService.startResetPassword(body);
        return success_response_1.HttpResponse.send('Token has been sent to your email address');
    }
    async resetPassword(body) {
        await this.adminService.resetPassword(body);
        return success_response_1.HttpResponse.send('Password reset successful');
    }
    async editStore(data, admin) {
        const response = await this.adminService.update(data, admin);
        return success_response_1.HttpResponse.send('Edited successful', response);
    }
    async changePassword(body, admin) {
        await this.adminService.changePassword(body, admin);
        return success_response_1.HttpResponse.send('Password reset successful');
    }
    async getAll() {
        const response = await this.adminService.getAll();
        return success_response_1.HttpResponse.send('User retrieved', response);
    }
    async get(id) {
        const response = await this.adminService.getOne(id);
        return success_response_1.HttpResponse.send('Edited successful', response);
    }
    onDelete(id) {
        return this.adminService.deleteById(id);
    }
};
__decorate([
    (0, common_1.UseGuards)(admin_guard_1.AdminGuard),
    (0, common_1.Post)('register'),
    (0, common_1.HttpCode)(200),
    openapi.ApiResponse({ status: 200, type: Object }),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [admin_dto_1.RegisterDTO]),
    __metadata("design:returntype", Promise)
], AdminController.prototype, "register", null);
__decorate([
    (0, common_1.Post)('register/validate'),
    (0, common_1.HttpCode)(200),
    openapi.ApiResponse({ status: 200, type: Object }),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [admin_dto_1.ValidateRegistrationDTO]),
    __metadata("design:returntype", Promise)
], AdminController.prototype, "verifyRegistration", null);
__decorate([
    (0, common_1.Post)('login'),
    (0, common_1.HttpCode)(200),
    openapi.ApiResponse({ status: 200, type: Object }),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [admin_dto_1.LoginDTO]),
    __metadata("design:returntype", Promise)
], AdminController.prototype, "login", null);
__decorate([
    (0, common_1.Post)('start_reset_password'),
    (0, common_1.HttpCode)(200),
    openapi.ApiResponse({ status: 200, type: Object }),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [admin_dto_1.StartResetPasswordDTO]),
    __metadata("design:returntype", Promise)
], AdminController.prototype, "startResetPassword", null);
__decorate([
    (0, common_1.Post)('reset_password'),
    (0, common_1.HttpCode)(200),
    openapi.ApiResponse({ status: 200, type: Object }),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [admin_dto_1.ResetPasswordDTO]),
    __metadata("design:returntype", Promise)
], AdminController.prototype, "resetPassword", null);
__decorate([
    (0, common_1.UseGuards)(admin_guard_1.AdminGuard),
    (0, common_1.Put)('accounts'),
    openapi.ApiResponse({ status: 200, type: Object }),
    __param(0, (0, common_1.Body)()),
    __param(1, (0, decorators_1.GetAdmin)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [admin_dto_1.EditUserDTO, admin_entity_1.Admin]),
    __metadata("design:returntype", Promise)
], AdminController.prototype, "editStore", null);
__decorate([
    (0, common_1.UseGuards)(admin_guard_1.AdminGuard),
    (0, common_1.Put)('accounts/password'),
    openapi.ApiResponse({ status: 200, type: Object }),
    __param(0, (0, common_1.Body)()),
    __param(1, (0, decorators_1.GetAdmin)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [admin_dto_1.ChangePasswordDTO,
        admin_entity_1.Admin]),
    __metadata("design:returntype", Promise)
], AdminController.prototype, "changePassword", null);
__decorate([
    (0, common_1.UseGuards)(admin_guard_1.AdminGuard),
    (0, common_1.Get)('accounts'),
    openapi.ApiResponse({ status: 200, type: Object }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], AdminController.prototype, "getAll", null);
__decorate([
    (0, common_1.UseGuards)(admin_guard_1.AdminGuard),
    (0, common_1.Get)('accounts/:id'),
    openapi.ApiResponse({ status: 200, type: Object }),
    __param(0, (0, common_1.Param)('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], AdminController.prototype, "get", null);
__decorate([
    (0, common_1.Delete)('accounts/:id'),
    openapi.ApiResponse({ status: 200 }),
    __param(0, (0, common_1.Param)('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], AdminController.prototype, "onDelete", null);
AdminController = __decorate([
    (0, common_1.Controller)('admin'),
    __metadata("design:paramtypes", [admin_service_1.AdminService])
], AdminController);
exports.AdminController = AdminController;
//# sourceMappingURL=admin.controller.js.map