"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AwardController = void 0;
const openapi = require("@nestjs/swagger");
const common_1 = require("@nestjs/common");
const user_entity_1 = require("../../models/user.entity");
const decorators_1 = require("../../common/decorators");
const guards_1 = require("../../common/guards");
const success_response_1 = require("../../common/helpers/responses/success.response");
const award_service_1 = require("./award.service");
const award_dto_1 = require("../../common/dto/award.dto");
let AwardController = class AwardController {
    constructor(awardService) {
        this.awardService = awardService;
    }
    async getAll(user) {
        const response = await this.awardService.getAll(user);
        return success_response_1.HttpResponse.send('Award retrieved', response);
    }
    async getAllV2() {
        const response = await this.awardService.getAllV2();
        return success_response_1.HttpResponse.send('Award retrieved', response);
    }
    async add(body) {
        console.log('add award', body);
        const response = await this.awardService.add(body);
        return success_response_1.HttpResponse.send('Award and options have been added', response);
    }
    async updaate(id, body) {
        console.log('update award', id, body);
        const response = await this.awardService.update(id, body);
        return success_response_1.HttpResponse.send('Award has been updated', response);
    }
    async addNominee(body, user) {
        console.log('addNominee award', body);
        const response = await this.awardService.addNominee(body, user);
        return success_response_1.HttpResponse.send('Nominee has been added', response);
    }
    onDelete(id) {
        console.log('delete award', id);
        return this.awardService.delete(id);
    }
};
__decorate([
    (0, common_1.Get)(''),
    openapi.ApiResponse({ status: 200, type: Object }),
    __param(0, (0, decorators_1.GetUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [user_entity_1.User]),
    __metadata("design:returntype", Promise)
], AwardController.prototype, "getAll", null);
__decorate([
    (0, common_1.Get)('v2'),
    openapi.ApiResponse({ status: 200, type: Object }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], AwardController.prototype, "getAllV2", null);
__decorate([
    (0, common_1.Post)(''),
    openapi.ApiResponse({ status: 201, type: Object }),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [award_dto_1.AwardDto]),
    __metadata("design:returntype", Promise)
], AwardController.prototype, "add", null);
__decorate([
    (0, common_1.Put)(''),
    openapi.ApiResponse({ status: 200, type: Object }),
    __param(0, (0, common_1.Param)('id')),
    __param(1, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, award_dto_1.AwardDto]),
    __metadata("design:returntype", Promise)
], AwardController.prototype, "updaate", null);
__decorate([
    (0, common_1.Post)('nominee'),
    openapi.ApiResponse({ status: 201, type: Object }),
    __param(0, (0, common_1.Body)()),
    __param(1, (0, decorators_1.GetUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [award_dto_1.AwardNominateDto, user_entity_1.User]),
    __metadata("design:returntype", Promise)
], AwardController.prototype, "addNominee", null);
__decorate([
    (0, common_1.Delete)(':id'),
    openapi.ApiResponse({ status: 200, type: Object }),
    __param(0, (0, common_1.Param)('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], AwardController.prototype, "onDelete", null);
AwardController = __decorate([
    (0, common_1.UseGuards)(guards_1.AuthGuard),
    (0, common_1.Controller)('awards'),
    __metadata("design:paramtypes", [award_service_1.AwardService])
], AwardController);
exports.AwardController = AwardController;
//# sourceMappingURL=award.controller.js.map