import { UserService } from './../user/user.service';
import { IServiceResponse } from 'src/common/interfaces/service.interface';
import { User } from 'src/models/user.entity';
import { Repository } from 'typeorm';
import { Award } from 'src/models/award.entity';
import { UserAward } from 'src/models/user-award.entity';
export declare class AwardService {
    private awardRepository;
    private userAwardRepository;
    private userService;
    constructor(awardRepository: Repository<Award>, userAwardRepository: Repository<UserAward>, userService: UserService);
    getAll(user: User): Promise<any>;
    getAllV2(): Promise<any>;
    add(payload: any): Promise<Award>;
    update(id: number, payload: any): Promise<Award>;
    addNominee(payload: any, user: User): Promise<Award>;
    delete(id: number): Promise<IServiceResponse>;
}
