"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DiscussionController = void 0;
const openapi = require("@nestjs/swagger");
const common_1 = require("@nestjs/common");
const guards_1 = require("../../common/guards");
const success_response_1 = require("../../common/helpers/responses/success.response");
const discussion_service_1 = require("./discussion.service");
const platform_express_1 = require("@nestjs/platform-express");
const multer_1 = require("multer");
const helper_1 = require("../../common/helpers/helper");
const discussion_dto_1 = require("../../common/dto/discussion.dto");
const swagger_1 = require("@nestjs/swagger");
const decorators_1 = require("../../common/decorators");
const user_entity_1 = require("../../models/user.entity");
let DiscussionController = class DiscussionController {
    constructor(discussionService) {
        this.discussionService = discussionService;
    }
    async getAll(query) {
        const response = await this.discussionService.getAll(query);
        return success_response_1.HttpResponse.send('Discussion retrieved', response);
    }
    async add(body, file, user) {
        const response = await this.discussionService.add(body, file, user);
        return success_response_1.HttpResponse.send('Discussion has been added', response);
    }
    onDelete(id) {
        console.log('delete match', id);
        return this.discussionService.delete(id);
    }
};
__decorate([
    (0, common_1.Get)(''),
    (0, swagger_1.ApiQuery)({ name: 'search', type: 'string' }),
    (0, swagger_1.ApiQuery)({ name: 'order', type: 'string' }),
    (0, swagger_1.ApiQuery)({ name: 'page', type: 'number' }),
    (0, swagger_1.ApiQuery)({ name: 'limit', type: 'number' }),
    openapi.ApiResponse({ status: 200, type: Object }),
    __param(0, (0, common_1.Query)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], DiscussionController.prototype, "getAll", null);
__decorate([
    (0, common_1.Post)(''),
    (0, common_1.UseInterceptors)((0, platform_express_1.FileInterceptor)('file', {
        storage: (0, multer_1.diskStorage)({
            destination: helper_1.Helper.destinationDiscussionPath,
            filename: helper_1.Helper.customFileName,
        }),
    })),
    openapi.ApiResponse({ status: 201, type: Object }),
    __param(0, (0, common_1.Body)()),
    __param(1, (0, common_1.UploadedFile)()),
    __param(2, (0, decorators_1.GetUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [discussion_dto_1.DiscussionDto, Object, user_entity_1.User]),
    __metadata("design:returntype", Promise)
], DiscussionController.prototype, "add", null);
__decorate([
    (0, common_1.Delete)(':id'),
    openapi.ApiResponse({ status: 200, type: Object }),
    __param(0, (0, common_1.Param)('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], DiscussionController.prototype, "onDelete", null);
DiscussionController = __decorate([
    (0, common_1.UseGuards)(guards_1.AuthGuard),
    (0, common_1.Controller)('discussions'),
    __metadata("design:paramtypes", [discussion_service_1.DiscussionService])
], DiscussionController);
exports.DiscussionController = DiscussionController;
//# sourceMappingURL=discussion.controller.js.map