"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DiscussionService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("typeorm");
const silly_animal_1 = require("silly-animal");
const nestjs_typeorm_paginate_1 = require("nestjs-typeorm-paginate");
let DiscussionService = class DiscussionService {
    constructor(discussionRepository) {
        this.discussionRepository = discussionRepository;
    }
    async getAll(payload) {
        var _a;
        let where = {};
        if (payload.search) {
            where = [
                { name: (0, typeorm_1.ILike)(`%${payload.search}%`) },
                { message: (0, typeorm_1.ILike)(`%${payload.search}%`) },
            ];
        }
        console.log(where);
        const { meta, items } = await (0, nestjs_typeorm_paginate_1.paginate)(this.discussionRepository, {
            page: payload.page ? Number(payload.page) : 1,
            limit: payload.limit ? Number(payload.limit) : 25,
        }, {
            where: where,
            order: {
                created_at: (_a = payload.order) !== null && _a !== void 0 ? _a : 'DESC',
            },
            relations: ['user'],
        });
        return {
            meta,
            items: items.map((item) => {
                return {
                    message: item.message,
                    name: item.name,
                    userId: item.user ? item.user.id : null,
                    created_at: item.created_at,
                    image: item.image,
                };
            }),
        };
    }
    async add(payload, file, user) {
        try {
            await this.discussionRepository.save({
                message: payload.message,
                name: (0, silly_animal_1.generate)(),
                image: file ? file.path.replace('public/', '') : null,
                user,
            });
        }
        catch (error) {
            throw new common_1.InternalServerErrorException(error.message);
        }
        return;
    }
    async delete(id) {
        await this.discussionRepository.softDelete({
            id,
        });
        return;
    }
};
DiscussionService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, common_1.Inject)('DISCUSSION_REPOSITORY')),
    __metadata("design:paramtypes", [typeorm_1.Repository])
], DiscussionService);
exports.DiscussionService = DiscussionService;
//# sourceMappingURL=discussion.service.js.map