"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EventController = void 0;
const openapi = require("@nestjs/swagger");
const common_1 = require("@nestjs/common");
const user_entity_1 = require("../../models/user.entity");
const decorators_1 = require("../../common/decorators");
const guards_1 = require("../../common/guards");
const success_response_1 = require("../../common/helpers/responses/success.response");
const event_dto_1 = require("../../common/dto/event.dto");
const event_service_1 = require("./event.service");
const platform_express_1 = require("@nestjs/platform-express");
const multer_1 = require("multer");
const helper_1 = require("../../common/helpers/helper");
let EventController = class EventController {
    constructor(eventService) {
        this.eventService = eventService;
    }
    async getAll() {
        const response = await this.eventService.getAll();
        return success_response_1.HttpResponse.send('Event retrieved', response);
    }
    async add(body, file) {
        const response = await this.eventService.add(body, file);
        return success_response_1.HttpResponse.send('Event has been added', response);
    }
    async updaate(id, body, file) {
        const response = await this.eventService.update(id, body, file);
        return success_response_1.HttpResponse.send('Event has been updated', response);
    }
    async addNominee(id, user) {
        const response = await this.eventService.join(id, user);
        return success_response_1.HttpResponse.send('Event has been added', response);
    }
    async addMany(body, user) {
        const response = await this.eventService.adMany(body, user);
        return success_response_1.HttpResponse.send('Many events have been updated', response);
    }
    onDelete(id) {
        return this.eventService.delete(id);
    }
};
__decorate([
    (0, common_1.Get)(''),
    openapi.ApiResponse({ status: 200, type: Object }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], EventController.prototype, "getAll", null);
__decorate([
    (0, common_1.Post)(''),
    (0, common_1.UseInterceptors)((0, platform_express_1.FileInterceptor)('file', {
        storage: (0, multer_1.diskStorage)({
            destination: helper_1.Helper.destinationEventPath,
            filename: helper_1.Helper.customFileName,
        }),
    })),
    openapi.ApiResponse({ status: 201, type: Object }),
    __param(0, (0, common_1.Body)()),
    __param(1, (0, common_1.UploadedFile)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [event_dto_1.EventDto, Object]),
    __metadata("design:returntype", Promise)
], EventController.prototype, "add", null);
__decorate([
    (0, common_1.Put)(':id'),
    (0, common_1.UseInterceptors)((0, platform_express_1.FileInterceptor)('file', {
        storage: (0, multer_1.diskStorage)({
            destination: helper_1.Helper.destinationEventPath,
            filename: helper_1.Helper.customFileName,
        }),
    })),
    openapi.ApiResponse({ status: 200, type: Object }),
    __param(0, (0, common_1.Param)('id')),
    __param(1, (0, common_1.Body)()),
    __param(2, (0, common_1.UploadedFile)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, event_dto_1.EventDto, Object]),
    __metadata("design:returntype", Promise)
], EventController.prototype, "updaate", null);
__decorate([
    (0, common_1.Post)('join/:id'),
    openapi.ApiResponse({ status: 201, type: Object }),
    __param(0, (0, common_1.Param)('id')),
    __param(1, (0, decorators_1.GetUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, user_entity_1.User]),
    __metadata("design:returntype", Promise)
], EventController.prototype, "addNominee", null);
__decorate([
    (0, common_1.Post)('update-many'),
    openapi.ApiResponse({ status: 201, type: Object }),
    __param(0, (0, common_1.Body)()),
    __param(1, (0, decorators_1.GetUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [event_dto_1.AddEventMutlipleDto, user_entity_1.User]),
    __metadata("design:returntype", Promise)
], EventController.prototype, "addMany", null);
__decorate([
    (0, common_1.Delete)(':id'),
    openapi.ApiResponse({ status: 200, type: Object }),
    __param(0, (0, common_1.Param)('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], EventController.prototype, "onDelete", null);
EventController = __decorate([
    (0, common_1.UseGuards)(guards_1.AuthGuard),
    (0, common_1.Controller)('events'),
    __metadata("design:paramtypes", [event_service_1.EventService])
], EventController);
exports.EventController = EventController;
//# sourceMappingURL=event.controller.js.map