"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EventService = void 0;
const user_service_1 = require("./../user/user.service");
const common_1 = require("@nestjs/common");
const typeorm_1 = require("typeorm");
let EventService = class EventService {
    constructor(eventRepository, userAwardRepository, userService) {
        this.eventRepository = eventRepository;
        this.userAwardRepository = userAwardRepository;
        this.userService = userService;
    }
    async getAll() {
        return await this.eventRepository.find();
    }
    async add(payload, file) {
        try {
            await this.eventRepository.save(Object.assign(Object.assign({}, payload), { image: file ? file.path.replace('public/', '') : null }));
        }
        catch (error) {
            throw new common_1.InternalServerErrorException(error.message);
        }
        return;
    }
    async update(id, payload, file) {
        try {
            const booking = await this.eventRepository.findOne({
                where: {
                    id: id,
                },
            });
            if (file) {
                booking.image = file.path.replace('public/', '');
            }
            if (payload.name) {
                booking.name = payload.name;
            }
            if (payload.description) {
                booking.description = payload.description;
            }
            await this.eventRepository.update({
                id: payload.id,
            }, booking);
        }
        catch (error) {
            throw new common_1.InternalServerErrorException(error.message);
        }
        return;
    }
    async join(id, user) {
        const event = await this.eventRepository.findOne({
            where: {
                id: id,
            },
        });
        await this.userAwardRepository.save({
            event,
            user,
        });
        return await this.userService.getOne(user.id);
    }
    async adMany(payload, user) {
        try {
            if (payload.options) {
                if (payload.options.length > 0) {
                    for (let i = 0; i < payload.options.length; i++) {
                        if (payload.options[i].status) {
                            const event = await this.eventRepository.findOne({
                                where: {
                                    id: payload.options[i].eventId,
                                },
                            });
                            await this.userAwardRepository.save({
                                event,
                                user,
                            });
                        }
                        else {
                            await this.userAwardRepository.delete({
                                user: {
                                    id: user.id,
                                },
                                event: {
                                    id: payload.options[i].eventId,
                                },
                            });
                        }
                    }
                }
            }
            return await this.userService.getOne(user.id);
        }
        catch (error) {
            throw new common_1.InternalServerErrorException(error.message);
        }
        return;
    }
    async delete(id) {
        await this.eventRepository.softDelete({
            id,
        });
        return;
    }
};
EventService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, common_1.Inject)('EVENT_REPOSITORY')),
    __param(1, (0, common_1.Inject)('USER_EVENT_REPOSITORY')),
    __metadata("design:paramtypes", [typeorm_1.Repository,
        typeorm_1.Repository,
        user_service_1.UserService])
], EventService);
exports.EventService = EventService;
//# sourceMappingURL=event.service.js.map