"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Matchontroller = void 0;
const openapi = require("@nestjs/swagger");
const common_1 = require("@nestjs/common");
const guards_1 = require("../../common/guards");
const success_response_1 = require("../../common/helpers/responses/success.response");
const match_service_1 = require("./match.service");
const match_dto_1 = require("../../common/dto/match.dto");
let Matchontroller = class Matchontroller {
    constructor(matchService) {
        this.matchService = matchService;
    }
    async getAll() {
        const response = await this.matchService.getAll();
        return success_response_1.HttpResponse.send('Match retrieved', response);
    }
    async add(body) {
        console.log('add match', body);
        const response = await this.matchService.add(body);
        return success_response_1.HttpResponse.send('Match has been added', response);
    }
    async updaate(id, body) {
        console.log('update match', id, body);
        const response = await this.matchService.update(id, body);
        return success_response_1.HttpResponse.send('Match has been updated', response);
    }
    onDelete(id) {
        console.log('delete match', id);
        return this.matchService.delete(id);
    }
};
__decorate([
    (0, common_1.Get)(''),
    openapi.ApiResponse({ status: 200, type: Object }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], Matchontroller.prototype, "getAll", null);
__decorate([
    (0, common_1.Post)(''),
    openapi.ApiResponse({ status: 201, type: Object }),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [match_dto_1.MatchDto]),
    __metadata("design:returntype", Promise)
], Matchontroller.prototype, "add", null);
__decorate([
    (0, common_1.Put)(':id'),
    openapi.ApiResponse({ status: 200, type: Object }),
    __param(0, (0, common_1.Param)('id')),
    __param(1, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, match_dto_1.UpdateMatchDto]),
    __metadata("design:returntype", Promise)
], Matchontroller.prototype, "updaate", null);
__decorate([
    (0, common_1.Delete)(':id'),
    openapi.ApiResponse({ status: 200, type: Object }),
    __param(0, (0, common_1.Param)('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], Matchontroller.prototype, "onDelete", null);
Matchontroller = __decorate([
    (0, common_1.UseGuards)(guards_1.AuthGuard),
    (0, common_1.Controller)('matches'),
    __metadata("design:paramtypes", [match_service_1.MatchService])
], Matchontroller);
exports.Matchontroller = Matchontroller;
//# sourceMappingURL=match.controller.js.map