"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MatchService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("typeorm");
const user_service_1 = require("../user/user.service");
let MatchService = class MatchService {
    constructor(matchRepository, userService) {
        this.matchRepository = matchRepository;
        this.userService = userService;
    }
    async getAll() {
        return await this.matchRepository.find();
    }
    async add(payload) {
        try {
            await this.matchRepository.save(Object.assign({}, payload));
            return;
        }
        catch (error) {
            throw new common_1.InternalServerErrorException(error.message);
        }
        return;
    }
    async update(id, payload) {
        try {
            const booking = await this.matchRepository.findOne({
                where: {
                    id: payload.id,
                },
            });
            if (payload.teamOneScore) {
                booking.teamOneScore = payload.teamOneScore;
            }
            if (payload.teamOne) {
                booking.teamOne = payload.teamOne;
            }
            if (payload.teamTwo) {
                booking.teamTwo = payload.teamTwo;
            }
            if (payload.teamTwoScore) {
                booking.teamTwoScore = payload.teamTwoScore;
            }
            if (payload.date) {
                booking.date = payload.date;
            }
            await this.matchRepository.update({
                id: payload.id,
            }, booking);
            return;
        }
        catch (error) {
            throw new common_1.InternalServerErrorException(error.message);
        }
        return;
    }
    async delete(id) {
        await this.matchRepository.softDelete({
            id,
        });
        return;
    }
};
MatchService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, common_1.Inject)('MATCH_REPOSITORY')),
    __metadata("design:paramtypes", [typeorm_1.Repository,
        user_service_1.UserService])
], MatchService);
exports.MatchService = MatchService;
//# sourceMappingURL=match.service.js.map