"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.QuestionController = void 0;
const openapi = require("@nestjs/swagger");
const common_1 = require("@nestjs/common");
const guards_1 = require("../../common/guards");
const success_response_1 = require("../../common/helpers/responses/success.response");
const question_service_1 = require("./question.service");
const question_dto_1 = require("../../common/dto/question.dto");
const decorators_1 = require("../../common/decorators");
const user_entity_1 = require("../../models/user.entity");
let QuestionController = class QuestionController {
    constructor(questionService) {
        this.questionService = questionService;
    }
    async getAll(user) {
        const response = await this.questionService.getAll(user);
        return success_response_1.HttpResponse.send('Question retrieved', response);
    }
    async scoreCard() {
        const response = await this.questionService.getScoreCard();
        return success_response_1.HttpResponse.send('Score card of users', response);
    }
    async add(body) {
        console.log('add question', body);
        const response = await this.questionService.add(body);
        return success_response_1.HttpResponse.send('Question and options have been added', response);
    }
    async updaate(id, body) {
        console.log('update question', id, body);
        const response = await this.questionService.update(id, body);
        return success_response_1.HttpResponse.send('Nominee has been updated', response);
    }
    async addAnswerToQuestion(questionId, answerId) {
        console.log('add answer question', questionId, answerId);
        const response = await this.questionService.addAnswerToQuestion(questionId, answerId);
        return success_response_1.HttpResponse.send('Answer has been added', response);
    }
    async answers(body, user) {
        console.log('score question answer', body, user);
        const response = await this.questionService.answers(body, user);
        return success_response_1.HttpResponse.send('Score has been added', response);
    }
    onDelete(id) {
        console.log('delete question', id);
        return this.questionService.delete(id);
    }
};
__decorate([
    (0, common_1.Get)(''),
    openapi.ApiResponse({ status: 200, type: Object }),
    __param(0, (0, decorators_1.GetUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [user_entity_1.User]),
    __metadata("design:returntype", Promise)
], QuestionController.prototype, "getAll", null);
__decorate([
    (0, common_1.Get)('score-card'),
    openapi.ApiResponse({ status: 200, type: Object }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], QuestionController.prototype, "scoreCard", null);
__decorate([
    (0, common_1.Post)(''),
    openapi.ApiResponse({ status: 201, type: Object }),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [question_dto_1.QuestionDto]),
    __metadata("design:returntype", Promise)
], QuestionController.prototype, "add", null);
__decorate([
    (0, common_1.Put)(''),
    openapi.ApiResponse({ status: 200, type: Object }),
    __param(0, (0, common_1.Param)('id')),
    __param(1, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, question_dto_1.QuestionDto]),
    __metadata("design:returntype", Promise)
], QuestionController.prototype, "updaate", null);
__decorate([
    (0, common_1.Post)('answer/:questionId/:answerId'),
    openapi.ApiResponse({ status: 201, type: Object }),
    __param(0, (0, common_1.Param)('questionId')),
    __param(1, (0, common_1.Param)('answerId')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], QuestionController.prototype, "addAnswerToQuestion", null);
__decorate([
    (0, common_1.Post)('score'),
    openapi.ApiResponse({ status: 201, type: Object }),
    __param(0, (0, common_1.Body)()),
    __param(1, (0, decorators_1.GetUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [question_dto_1.AnswersDto, user_entity_1.User]),
    __metadata("design:returntype", Promise)
], QuestionController.prototype, "answers", null);
__decorate([
    (0, common_1.Delete)(':id'),
    openapi.ApiResponse({ status: 200, type: Object }),
    __param(0, (0, common_1.Param)('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], QuestionController.prototype, "onDelete", null);
QuestionController = __decorate([
    (0, common_1.UseGuards)(guards_1.AuthGuard),
    (0, common_1.Controller)('questions'),
    __metadata("design:paramtypes", [question_service_1.QuestionService])
], QuestionController);
exports.QuestionController = QuestionController;
//# sourceMappingURL=question.controller.js.map