"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SantaController = void 0;
const openapi = require("@nestjs/swagger");
const common_1 = require("@nestjs/common");
const guards_1 = require("../../common/guards");
const success_response_1 = require("../../common/helpers/responses/success.response");
const santa_dto_1 = require("../../common/dto/santa.dto");
const santa_service_1 = require("./santa.service");
let SantaController = class SantaController {
    constructor(santaService) {
        this.santaService = santaService;
    }
    async getAll() {
        const response = await this.santaService.getAll();
        return success_response_1.HttpResponse.send('Bookings retrieved', response);
    }
    async add(body) {
        const response = await this.santaService.addOrUpdate(body);
        return success_response_1.HttpResponse.send('Bookings has been added', response);
    }
    async generate() {
        const response = await this.santaService.generate();
        return success_response_1.HttpResponse.send('Bookings has been added', response);
    }
    onDelete(id) {
        return this.santaService.delete(id);
    }
};
__decorate([
    (0, common_1.Get)(''),
    openapi.ApiResponse({ status: 200, type: Object }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], SantaController.prototype, "getAll", null);
__decorate([
    (0, common_1.Post)(''),
    openapi.ApiResponse({ status: 201, type: Object }),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [santa_dto_1.SantaDto]),
    __metadata("design:returntype", Promise)
], SantaController.prototype, "add", null);
__decorate([
    (0, common_1.Post)('generate'),
    openapi.ApiResponse({ status: 201, type: Object }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], SantaController.prototype, "generate", null);
__decorate([
    (0, common_1.Delete)(':id'),
    openapi.ApiResponse({ status: 200, type: Object }),
    __param(0, (0, common_1.Param)('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], SantaController.prototype, "onDelete", null);
SantaController = __decorate([
    (0, common_1.UseGuards)(guards_1.AuthGuard),
    (0, common_1.Controller)('santa'),
    __metadata("design:paramtypes", [santa_service_1.SantaService])
], SantaController);
exports.SantaController = SantaController;
//# sourceMappingURL=santa.controller.js.map