"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SantaService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("typeorm");
const user_service_1 = require("../user/user.service");
let SantaService = class SantaService {
    constructor(santaRepository, userService) {
        this.santaRepository = santaRepository;
        this.userService = userService;
    }
    async getAll() {
        return await this.santaRepository.find();
    }
    async getByUserId(userId) {
        return await this.santaRepository
            .createQueryBuilder('santa')
            .leftJoinAndSelect('santa.firstUser', 'firstUser')
            .leftJoinAndSelect('santa.secondUser', 'secondUser')
            .where(`santa.firstUser.id = ${userId}  or santa.secondUser.id = ${userId}`)
            .getOne();
    }
    async addOrUpdate(payload) {
        try {
            const firstUser = await this.userService.getOne(payload.firstUserId);
            const secondUser = await this.userService.getOne(payload.secondUserId);
            if (!payload.id) {
                await this.santaRepository.save({
                    firstUser: firstUser,
                    secondUser: secondUser,
                });
            }
            else {
                await this.santaRepository.update({
                    id: payload.id,
                }, {
                    firstUser: firstUser,
                    secondUser: secondUser,
                });
            }
        }
        catch (error) {
            throw new common_1.InternalServerErrorException(error.message);
        }
        return;
    }
    async generate() {
        try {
            while ((await this.userService.isSantaNull()) != null) {
                const user = await this.userService.isSantaNull();
                if (user) {
                    const djddj = await this.userService.getOneBySantaIsNull(user.id);
                    if (djddj) {
                        if (!(await this.userService.existBySantaId(djddj.id))) {
                            user.santaId = djddj.id;
                            user.save();
                        }
                    }
                }
            }
        }
        catch (error) {
            console.log(error);
        }
        return;
    }
    async delete(id) {
        await this.santaRepository.softDelete({
            id: id,
        });
        return;
    }
};
SantaService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, common_1.Inject)('SANTA_REPOSITORY')),
    __param(1, (0, common_1.Inject)((0, common_1.forwardRef)(() => user_service_1.UserService))),
    __metadata("design:paramtypes", [typeorm_1.Repository,
        user_service_1.UserService])
], SantaService);
exports.SantaService = SantaService;
//# sourceMappingURL=santa.service.js.map