"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UserController = void 0;
const openapi = require("@nestjs/swagger");
const common_1 = require("@nestjs/common");
const user_service_1 = require("./user.service");
const user_dto_1 = require("../../common/dto/user.dto");
const success_response_1 = require("../../common/helpers/responses/success.response");
const admin_dto_1 = require("../../common/dto/admin.dto");
const guards_1 = require("../../common/guards");
const decorators_1 = require("../../common/decorators");
const user_entity_1 = require("../../models/user.entity");
const platform_express_1 = require("@nestjs/platform-express");
const multer_1 = require("multer");
const helper_1 = require("../../common/helpers/helper");
const swagger_1 = require("@nestjs/swagger");
let UserController = class UserController {
    constructor(userService) {
        this.userService = userService;
    }
    async add(file) {
        const response = await this.userService.updateNames(file);
        return success_response_1.HttpResponse.send('Users has been added', response);
    }
    async hasCheckedIn(email) {
        const response = await this.userService.hasCheckedIn(email);
        return success_response_1.HttpResponse.send('Users retrieved', response);
    }
    async getAll(query) {
        const response = await this.userService.getAll(query);
        return success_response_1.HttpResponse.send('Users retrieved', response);
    }
    async getCurrentUser(user) {
        const response = await this.userService.currentUser(user);
        return success_response_1.HttpResponse.send('Users retrieved', response);
    }
    async put(body, user) {
        const response = await this.userService.update(body, user);
        return success_response_1.HttpResponse.send('Users retrieved', response);
    }
    async login(body) {
        const response = await this.userService.login(body);
        return success_response_1.HttpResponse.send('Registration successful', response);
    }
    async startResetPassword(body) {
        await this.userService.startResetPassword(body);
        return success_response_1.HttpResponse.send('Token has been sent to your email address');
    }
    async onAddEmail(email) {
        const response = await this.userService.addUser(email);
        return success_response_1.HttpResponse.send('Users has been added', response);
    }
};
__decorate([
    (0, common_1.Post)(''),
    (0, common_1.UseInterceptors)((0, platform_express_1.FileInterceptor)('file', {
        storage: (0, multer_1.diskStorage)({
            destination: helper_1.Helper.destinationEventPath,
            filename: helper_1.Helper.customFileName,
        }),
    })),
    openapi.ApiResponse({ status: 201, type: Object }),
    __param(0, (0, common_1.UploadedFile)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], UserController.prototype, "add", null);
__decorate([
    (0, common_1.UseGuards)(guards_1.AuthGuard),
    (0, common_1.Post)('users/check_in/:email'),
    openapi.ApiResponse({ status: 201, type: Object }),
    __param(0, (0, common_1.Param)('email')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], UserController.prototype, "hasCheckedIn", null);
__decorate([
    (0, common_1.UseGuards)(guards_1.AuthGuard),
    (0, common_1.Get)('users'),
    (0, swagger_1.ApiQuery)({ name: 'search', type: 'string' }),
    openapi.ApiResponse({ status: 200, type: Object }),
    __param(0, (0, common_1.Query)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], UserController.prototype, "getAll", null);
__decorate([
    (0, common_1.UseGuards)(guards_1.AuthGuard),
    (0, common_1.Get)('current_user'),
    openapi.ApiResponse({ status: 200, type: Object }),
    __param(0, (0, decorators_1.GetUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [user_entity_1.User]),
    __metadata("design:returntype", Promise)
], UserController.prototype, "getCurrentUser", null);
__decorate([
    (0, common_1.UseGuards)(guards_1.AuthGuard),
    (0, common_1.Put)('users'),
    openapi.ApiResponse({ status: 200, type: Object }),
    __param(0, (0, common_1.Body)()),
    __param(1, (0, decorators_1.GetUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [user_dto_1.UpdateUserDto, user_entity_1.User]),
    __metadata("design:returntype", Promise)
], UserController.prototype, "put", null);
__decorate([
    (0, common_1.Post)('auth/login_confirm'),
    (0, common_1.HttpCode)(200),
    openapi.ApiResponse({ status: 200, type: Object }),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [user_dto_1.LoginDTO]),
    __metadata("design:returntype", Promise)
], UserController.prototype, "login", null);
__decorate([
    (0, common_1.Post)('auth/login'),
    (0, common_1.HttpCode)(200),
    openapi.ApiResponse({ status: 200, type: Object }),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [admin_dto_1.StartResetPasswordDTO]),
    __metadata("design:returntype", Promise)
], UserController.prototype, "startResetPassword", null);
__decorate([
    (0, common_1.Get)(':email'),
    openapi.ApiResponse({ status: 200, type: Object }),
    __param(0, (0, common_1.Param)('email')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], UserController.prototype, "onAddEmail", null);
UserController = __decorate([
    (0, common_1.Controller)(),
    (0, common_1.UseInterceptors)(common_1.ClassSerializerInterceptor),
    __metadata("design:paramtypes", [user_service_1.UserService])
], UserController);
exports.UserController = UserController;
//# sourceMappingURL=user.controller.js.map