import { Repository } from 'typeorm';
import { IServiceResponse } from '../../common/interfaces/service.interface';
import { User } from '../../models/user.entity';
import { HttpService } from '@nestjs/axios';
import { SantaService } from '../santa/santa.service';
export declare class UserService {
    private readonly userRepository;
    private readonly httpService;
    private readonly santaService;
    constructor(userRepository: Repository<User>, httpService: HttpService, santaService: SantaService);
    updateNames(file: any): Promise<void>;
    addUser(email: any): Promise<void>;
    hasCheckedIn(email: string): Promise<any>;
    getAll(payload: any): Promise<any>;
    currentUser(user: User): Promise<any>;
    update(parameter: any, usr: User): Promise<any>;
    startResetPassword(parameter: any): Promise<IServiceResponse>;
    dispatchMessage(message: string, recipients: string): Promise<any>;
    login(payload: any): Promise<any>;
    getByEmai(email: string): Promise<boolean>;
    getOne(id: number): Promise<User>;
    getOneBySanta(id: number): Promise<User>;
    getSecSentaByUser(user: User): Promise<User>;
    existBySantaId(id: number): Promise<boolean>;
    getOneBySantaIsNull(id: number): Promise<User>;
    isSantaNull(): Promise<User>;
}
