"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UserService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("typeorm");
const jwt_utilities_1 = require("../../common/helpers/utilities/jwt.utilities");
const user_entity_1 = require("../../models/user.entity");
const rxjs_1 = require("rxjs");
const axios_1 = require("@nestjs/axios");
const santa_service_1 = require("../santa/santa.service");
const csvtojson_1 = require("csvtojson");
let UserService = class UserService {
    constructor(userRepository, httpService, santaService) {
        this.userRepository = userRepository;
        this.httpService = httpService;
        this.santaService = santaService;
    }
    async updateNames(file) {
        (0, csvtojson_1.default)({
            noheader: true,
            output: 'csv',
        })
            .fromFile(file.path)
            .then(async (result) => {
            await Promise.all(result.map(async (record) => {
                try {
                    const user = new user_entity_1.User();
                    user.email = record[0];
                    const isExist = await this.getByEmai(user.email);
                    if (!isExist) {
                        const arr = user.email.split('@');
                        if (arr.length > 0) {
                            const names = arr[0].split('.');
                            if (names.length > 0) {
                                user.firstName = names[0];
                                user.lastName = names[1];
                                user.save();
                            }
                        }
                    }
                }
                catch (error) { }
                return;
            }));
        });
    }
    async addUser(email) {
        const isExist = await this.getByEmai(email);
        if (!isExist) {
            const user = new user_entity_1.User();
            user.email = email;
            const arr = user.email.split('@');
            if (arr.length > 0) {
                const names = arr[0].split('.');
                if (names.length > 0) {
                    user.firstName = names[0];
                    user.lastName = names[1];
                    user.save();
                }
            }
        }
    }
    async hasCheckedIn(email) {
        const user = await this.userRepository.findOne({
            where: {
                email,
            },
        });
        if (user && !user.isCheckedIn) {
            user.isCheckedIn = true;
            user.checkedIndate = new Date();
            user.save();
            return {
                checkIn: false,
            };
        }
        return {
            checkIn: true,
            time: user.checkedIndate,
        };
    }
    async getAll(payload) {
        let where = {};
        if (payload.search) {
            where = [
                { lastName: (0, typeorm_1.ILike)(`%${payload.search}%`) },
                { firstName: (0, typeorm_1.ILike)(`%${payload.search}%`) },
            ];
        }
        return await this.userRepository.find({
            where: where,
        });
    }
    async currentUser(user) {
        const userData = await this.userRepository.findOne({
            where: {
                id: user.id,
            },
            relations: ['userEvents', 'userEvents.event', 'santa'],
        });
        return userData;
    }
    async update(parameter, usr) {
        console.log('update', parameter, usr);
        const user = await this.getOne(usr.id);
        if (parameter.firstName) {
            user.firstName = parameter.firstName;
        }
        if (parameter.lastName) {
            user.lastName = parameter.lastName;
        }
        if (parameter.favouriteLeisure) {
            user.favouriteLeisure = parameter.favouriteLeisure;
        }
        if (parameter.hobby) {
            user.hobby = parameter.hobby;
        }
        if (parameter.wishlist) {
            user.wishlist = parameter.wishlist;
            user.joinSanta = true;
        }
        if (parameter.position) {
            user.position = parameter.position;
        }
        if (parameter.activeTicket != null) {
            user.activeTicket = parameter.activeTicket;
        }
        user.save();
        return user;
    }
    async startResetPassword(parameter) {
        console.log('startResetPassword', parameter);
        const account = await this.userRepository
            .createQueryBuilder('user')
            .where(`LOWER(email) = '${parameter.email.toLowerCase()}'`)
            .getOne();
        if (!account) {
            throw new common_1.BadRequestException('The account does not exist');
        }
        const randomNumber = Math.floor(Math.random() * (9999 - 1000 + 1)) + 1000;
        await this.userRepository.update({
            id: account.id,
        }, {
            verification_token: randomNumber,
        });
        this.dispatchMessage(`Login token: ${randomNumber}`, parameter.email);
        return;
    }
    async dispatchMessage(message, recipients) {
        const params = {
            send: 'code',
            email: recipients,
            connection: 'email',
            client_id: 'bHQt8TZ50R5Hqn17BmBigFRPpci09PXf',
            client_secret: 'uPlj-JOehxrS9U84rm0LtgKIRgn0vmZx2UXfsvTQJN9L6UcGZ9GmM62MaUCX7X26',
        };
        const data = Object.keys(params)
            .map((key) => `${key}=${encodeURIComponent(params[key])}`)
            .join('&');
        try {
            const smsResponse = await (0, rxjs_1.lastValueFrom)(this.httpService
                .post('https://mtnng-finco-uat.mtn-dev.auth0.com/passwordless/start', data, {
                headers: { 'Content-Type': 'application/x-www-form-urlencoded' },
            })
                .pipe((0, rxjs_1.map)((res) => res.data)));
            console.log('dddddd');
            console.log(smsResponse);
        }
        catch (error) {
            console.log(error);
        }
    }
    async login(payload) {
        console.log('login', payload);
        const account = await this.userRepository
            .createQueryBuilder('user')
            .where(`LOWER(email) = '${payload.email.toLowerCase()}'`)
            .getOne();
        const params = {
            grant_type: 'http://auth0.com/oauth/grant-type/passwordless/otp',
            client_id: 'bHQt8TZ50R5Hqn17BmBigFRPpci09PXf',
            client_secret: 'uPlj-JOehxrS9U84rm0LtgKIRgn0vmZx2UXfsvTQJN9L6UcGZ9GmM62MaUCX7X26',
            otp: payload.token,
            realm: 'email',
            username: payload.email,
            audience: 'https://momo.com',
            scope: 'openid profile email offline_access firstname lastname',
            connection: 'email',
        };
        const data = Object.keys(params)
            .map((key) => `${key}=${encodeURIComponent(params[key])}`)
            .join('&');
        try {
            const smsResponse = await (0, rxjs_1.lastValueFrom)(this.httpService
                .post('https://mtnng-finco-uat.mtn-dev.auth0.com/oauth/token', data, {
                headers: { 'Content-Type': 'application/x-www-form-urlencoded' },
            })
                .pipe((0, rxjs_1.map)((res) => res.data)));
            return {
                token: await jwt_utilities_1.JwtUtilities.signToken(account),
                user: account,
            };
        }
        catch (error) {
            throw new common_1.BadRequestException('You could be utilizing an incorrect one-time password (OTP) or it has expired');
        }
    }
    async getByEmai(email) {
        return await this.userRepository.exist({
            where: {
                email,
            },
        });
    }
    async getOne(id) {
        const role = await this.userRepository.findOne({
            where: {
                id: id,
            },
            relations: ['userEvents', 'userEvents.event'],
        });
        if (!role) {
            throw new common_1.NotFoundException('Invalid user');
        }
        return role;
    }
    async getOneBySanta(id) {
        return await this.userRepository
            .createQueryBuilder('user')
            .leftJoinAndSelect('user.firstSanta', 'firstSanta')
            .leftJoinAndSelect('user.secondSanta', 'secondSanta')
            .where('user.joinSanta = :joinSanta', { joinSanta: true })
            .andWhere('user.id = :id', { id: id })
            .andWhere('firstSanta.id is null')
            .andWhere('secondSanta.id is null')
            .getOne();
    }
    async getSecSentaByUser(user) {
        return await this.userRepository
            .createQueryBuilder('user')
            .leftJoinAndSelect('user.firstSanta', 'firstSanta')
            .leftJoinAndSelect('user.secondSanta', 'secondSanta')
            .where('user.joinSanta = :joinSanta', { joinSanta: true })
            .andWhere('user.id != :id', { id: user.id })
            .andWhere('firstSanta.id is null')
            .andWhere('secondSanta.id is null')
            .orderBy('RAND()')
            .getOne();
    }
    async existBySantaId(id) {
        return await this.userRepository.exist({
            where: {
                santaId: id,
                joinSanta: true,
            },
        });
    }
    async getOneBySantaIsNull(id) {
        return await this.userRepository
            .createQueryBuilder('user')
            .where('user.joinSanta = :joinSanta', { joinSanta: true })
            .andWhere('user.id != :id', { id })
            .orderBy('RAND()')
            .getOne();
    }
    async isSantaNull() {
        return await this.userRepository
            .createQueryBuilder('user')
            .where('user.joinSanta = :joinSanta', { joinSanta: true })
            .andWhere('santaId is null')
            .orderBy('RAND()')
            .getOne();
    }
};
UserService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, common_1.Inject)('USER_REPOSITORY')),
    __metadata("design:paramtypes", [typeorm_1.Repository,
        axios_1.HttpService,
        santa_service_1.SantaService])
], UserService);
exports.UserService = UserService;
//# sourceMappingURL=user.service.js.map